<template>
  <div class="buttons-container full-width">
    <div class="buttons-container__single-button-wrapper">
      <q-btn
        :href="methodologyDownloadLink"
        target="_blank"
        class="single-button full-width"
        color="primary"
        text-color="white"
        padding="sm xs"
        push
        no-caps
      >
        <div class="single-button__content full-width row justify-evenly items-center">
          <img class="single-button__content__icon" src="../../../assets/icons/icon-metodologia.svg" alt="">
          <span class="single-button__content__label">Metodología</span>
        </div>
      </q-btn>
    </div>

    <div class="buttons-container__single-button-wrapper">
      <q-btn
        class="single-button full-width"
        color="primary"
        text-color="white"
        padding="sm xs"
        push
        no-caps
        :disable="isFetching"
      >
        <div class="single-button__content full-width row justify-evenly items-center">
          <img class="single-button__content__icon" src="../../../assets/icons/icon-datos.svg" alt="Icono descargar datos">
          <span class="single-button__content__label">Datos</span>
        </div>
        <q-menu :disable="isFetching"  fit anchor="bottom middle" self="top middle" auto-close>
          <q-list separator bordered>
            <q-item clickable @click="downloadCSV()">
              <q-item-section>
                <q-item-label header>
                  Archivo CSV
                </q-item-label>
              </q-item-section>
            </q-item>
            <q-item clickable @click="downloadXLSX()">
              <q-item-section>
                <q-item-label header>
                  Archivo XLS
                </q-item-label>
              </q-item-section>
            </q-item>
          </q-list>
        </q-menu>
      </q-btn>
    </div>

    <div class="buttons-container__single-button-wrapper">
      <q-btn
        class="single-button full-width"
        color="primary"
        text-color="white"
        padding="sm xs"
        push
        no-caps
        :disable="isFetching"
      >
        <div class="single-button__content full-width row justify-evenly items-center">
          <img class="single-button__content__icon" src="../../../assets/icons/icon-grafico.svg" alt="Icono descargar grafico">
          <span class="single-button__content__label">Gráfico</span>
        </div>
        <q-menu :disable="isFetching"  fit anchor="bottom middle" self="top middle" auto-close>
          <q-list separator bordered>
            <q-item clickable @click="downloadReport('png')">
              <q-item-section>
                <q-item-label header>
                  Descarga PNG
                </q-item-label>
              </q-item-section>
            </q-item>
            <q-item clickable @click="downloadReport('jpg')">
              <q-item-section>
                <q-item-label header>
                  Descarga JPG
                </q-item-label>
              </q-item-section>
            </q-item>
            <q-item clickable @click="downloadReport('pdf')">
              <q-item-section>
                <q-item-label header>
                  Descarga PDF
                </q-item-label>
              </q-item-section>
            </q-item>
          </q-list>
        </q-menu>
      </q-btn>
    </div>
  </div>
</template>

<script setup>
import { computed } from 'vue';
import getMethodologyDownloadLink from 'src/composables/get_methodology_download_link';
import { downloadDataCSV, downloadDataXLSX } from 'src/composables/get_data_csv_xls';
import makeReport from 'src/composables/get_data_image_pdf';

const props = defineProps({
  indicator:            { type: String, required: true },
  indicatorTitle:       { type: String, required: true },
  indicatorDescription: { type: String, required: true },
  dynamicHeader:        { type: Array, required: true },
  data:                 { type: Object, required: true },
  isFetching:           { type: Boolean, required: true },
  toggleSelectedValue:  { type: String },
})

const isFetching = computed({
  get: () => props.isFetching
});

const chartData = computed({
  get: () => props.data.chartData
});

const indicator = computed({
  get: () => props.indicator
});

const indicatorTitle = computed({
  get: () => props.indicatorTitle
});

const indicatorDescription = computed({
  get: () => props.indicatorDescription
});

const dynamicHeader = computed({
  get: () => props.dynamicHeader
});

const data = computed({
  get: () => props.data
});

const methodologyDownloadLink = computed(() => getMethodologyDownloadLink(props.indicator, props.toggleSelectedValue));

const downloadCSV = () => downloadDataCSV(props.indicator, chartData.value);
const downloadXLSX = () => downloadDataXLSX(props.indicator, chartData.value);

const downloadReport = (extension) => {
  makeReport(
    indicator.value,
    indicatorTitle.value,
    indicatorDescription.value,
    dynamicHeader.value,
    data.value,
    extension
  )
};

</script>

<style lang="scss">
@use './download-buttons-component-stylesheet.scss';
</style>